Package: blob
Title: A Simple S3 Class for Representing Vectors of Binary Data
        ('BLOBS')
Version: 1.2.4
Authors@R: c(
    person("Hadley", "Wickham", role = "aut"),
    person("Kirill", "Müller", , "kirill@cynkra.com", role = "cre"),
    person("RStudio", role = c("cph", "fnd"))
  )
Description: R's raw vector is useful for storing a single binary object.
    What if you want to put a vector of them in a data frame? The 'blob'
    package provides the blob object, a list of raw vectors, suitable for
    use as a column in data frame.
License: MIT + file LICENSE
URL: https://blob.tidyverse.org, https://github.com/tidyverse/blob
BugReports: https://github.com/tidyverse/blob/issues
Imports: methods, rlang, vctrs (>= 0.2.1)
Suggests: covr, crayon, pillar (>= 1.2.1), testthat
Config/autostyle/scope: line_breaks
Config/autostyle/strict: false
Config/Needs/website: tidyverse/tidytemplate
Encoding: UTF-8
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2023-03-17 09:42:50 UTC; kirill
Author: Hadley Wickham [aut],
  Kirill Müller [cre],
  RStudio [cph, fnd]
Maintainer: Kirill Müller <kirill@cynkra.com>
Repository: CRAN
Date/Publication: 2023-03-17 12:00:06 UTC
Built: R 4.2.0; ; 2023-03-17 13:26:47 UTC; unix

Package: blob
Title: A Simple S3 Class for Representing Vectors of Binary Data ('BLOBS')
Version: 1.2.4.9000
Authors@R: c(
    person("Hadley", "Wickham", role = "aut"),
    person("Kirill", "Müller", , "kirill@cynkra.com", role = "cre"),
    person("RStudio", role = c("cph", "fnd"))
  )
Description: R's raw vector is useful for storing a single binary object.
    What if you want to put a vector of them in a data frame? The 'blob'
    package provides the blob object, a list of raw vectors, suitable for
    use as a column in data frame.
License: MIT + file LICENSE
URL: https://blob.tidyverse.org, https://github.com/tidyverse/blob
BugReports: https://github.com/tidyverse/blob/issues
Imports: 
    methods,
    rlang,
    vctrs (>= 0.2.1)
Suggests: 
    covr,
    crayon,
    pillar (>= 1.2.1),
    testthat
Config/autostyle/scope: line_breaks
Config/autostyle/strict: false
Config/Needs/website: tidyverse/tidytemplate
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![rcc](https://github.com/tidyverse/blob/workflows/rcc/badge.svg)](https://github.com/tidyverse/blob/actions)
[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/blob)](https://cran.r-project.org/package=blob)
[![Coverage
Status](https://codecov.io/gh/tidyverse/blob/branch/main/graph/badge.svg)](https://app.codecov.io/gh/tidyverse/blob)
<!-- badges: end -->

<!-- README.md is generated from README.Rmd. Please edit that file -->

# blob

## Overview

The goal of blob is to provide a simple S3 class to represent a vector
of binary objects, aka blobs. The `blob` class is a lightweight wrapper
around a list of raw vectors, suitable for inclusion in a data frame.

In most cases you will not need to use this package explicitly: it will
be used transparently by packages that need to load BLOB columns from
databases or binary file formats.

## Installation

``` r
# The easiest way to get blob is to install the whole tidyverse:
install.packages("tidyverse")

# Alternatively, install just blob:
install.packages("blob")

# Or the development version from GitHub:
# install.packages("pak")
pak::pak("tidyverse/blob")
```

## Example

To create a blob, use `blob()`, `new_blob()` or `as_blob()`:

``` r
library(blob)

x1 <- charToRaw("Good morning")
x2 <- as.raw(c(0x48, 0x65, 0x6c, 0x6c, 0x6f))

new_blob(list(x1, x2))
#> <blob[2]>
#> [1] blob[12 B] blob[5 B]
blob(x1, x2)
#> <blob[2]>
#> [1] blob[12 B] blob[5 B]

as_blob(c("Good morning", "Good evening"))
#> <blob[2]>
#> [1] blob[12 B] blob[12 B]
```

------------------------------------------------------------------------

Please note that the ‘blob’ project is released with a [Contributor Code
of
Conduct](https://github.com/tidyverse/blob/blob/main/CODE_OF_CONDUCT.md).
By contributing to this project, you agree to abide by its terms.

<!-- badges: start -->

[![Lifecycle: stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable) [![rcc](https://github.com/tidyverse/blob/workflows/rcc/badge.svg)](https://github.com/tidyverse/blob/actions) [![CRAN\_Status\_Badge](https://www.r-pkg.org/badges/version/blob)](https://cran.r-project.org/package=blob) [![Coverage Status](https://codecov.io/gh/tidyverse/blob/branch/main/graph/badge.svg)](https://codecov.io/github/tidyverse/blob?branch=main)

<!-- badges: end -->

<!-- README.md is generated from README.Rmd. Please edit that file -->

# blob

## Overview

The goal of blob is to provide a simple S3 class to represent a vector of binary objects, aka blobs. The `blob` class is a lightweight wrapper around a list of raw vectors, suitable for inclusion in a data frame.

In most cases you will not need to use this package explicitly: it will be used transparently by packages that need to load BLOB columns from databases or binary file formats.

## Installation

<pre class='chroma'>
<span class='c'># The easiest way to get blob is to install the whole tidyverse:</span>
<span class='nf'><a href='https://rdrr.io/r/utils/install.packages.html'>install.packages</a></span><span class='o'>(</span><span class='s'>"tidyverse"</span><span class='o'>)</span>

<span class='c'># Alternatively, install just blob:</span>
<span class='nf'><a href='https://rdrr.io/r/utils/install.packages.html'>install.packages</a></span><span class='o'>(</span><span class='s'>"blob"</span><span class='o'>)</span>

<span class='c'># Or the the development version from GitHub:</span>
<span class='c'># install.packages("devtools")</span>
<span class='nf'>devtools</span><span class='nf'>::</span><span class='nf'><a href='https://devtools.r-lib.org//reference/remote-reexports.html'>install_github</a></span><span class='o'>(</span><span class='s'>"tidyverse/blob"</span><span class='o'>)</span></pre>

## Example

To create a blob, use `blob()`, `new_blob()` or `as_blob()`:

<pre class='chroma'>
<span class='kr'><a href='https://rdrr.io/r/base/library.html'>library</a></span><span class='o'>(</span><span class='nv'><a href='https://blob.tidyverse.org'>blob</a></span><span class='o'>)</span>

<span class='nv'>x1</span> <span class='o'>&lt;-</span> <span class='nf'><a href='https://rdrr.io/r/base/rawConversion.html'>charToRaw</a></span><span class='o'>(</span><span class='s'>"Good morning"</span><span class='o'>)</span>
<span class='nv'>x2</span> <span class='o'>&lt;-</span> <span class='nf'><a href='https://rdrr.io/r/base/raw.html'>as.raw</a></span><span class='o'>(</span><span class='nf'><a href='https://rdrr.io/r/base/c.html'>c</a></span><span class='o'>(</span><span class='m'>0x48</span>, <span class='m'>0x65</span>, <span class='m'>0x6c</span>, <span class='m'>0x6c</span>, <span class='m'>0x6f</span><span class='o'>)</span><span class='o'>)</span>

<span class='nf'><a href='https://blob.tidyverse.org/reference/blob.html'>new_blob</a></span><span class='o'>(</span><span class='nf'><a href='https://rdrr.io/r/base/list.html'>list</a></span><span class='o'>(</span><span class='nv'>x1</span>, <span class='nv'>x2</span><span class='o'>)</span><span class='o'>)</span>
<span class='c'>#&gt; &lt;blob[2]&gt;</span>
<span class='c'>#&gt; [1] blob[12 B] blob[5 B]</span>
<span class='nf'><a href='https://blob.tidyverse.org/reference/blob.html'>blob</a></span><span class='o'>(</span><span class='nv'>x1</span>, <span class='nv'>x2</span><span class='o'>)</span>
<span class='c'>#&gt; &lt;blob[2]&gt;</span>
<span class='c'>#&gt; [1] blob[12 B] blob[5 B]</span>

<span class='nf'><a href='https://blob.tidyverse.org/reference/blob.html'>as_blob</a></span><span class='o'>(</span><span class='nf'><a href='https://rdrr.io/r/base/c.html'>c</a></span><span class='o'>(</span><span class='s'>"Good morning"</span>, <span class='s'>"Good evening"</span><span class='o'>)</span><span class='o'>)</span>
<span class='c'>#&gt; &lt;blob[2]&gt;</span>
<span class='c'>#&gt; [1] blob[12 B] blob[12 B]</span></pre>

------------------------------------------------------------------------

Please note that the ‘blob’ project is released with a [Contributor Code of Conduct](https://github.com/tidyverse/blob/blob/main/CODE_OF_CONDUCT.md). By contributing to this project, you agree to abide by its terms.

---
output: downlit::readme_document
---

<!-- badges: start -->
[![Lifecycle: stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![rcc](https://github.com/tidyverse/blob/workflows/rcc/badge.svg)](https://github.com/tidyverse/blob/actions)
[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/blob)](https://cran.r-project.org/package=blob)
[![Coverage Status](https://codecov.io/gh/tidyverse/blob/branch/main/graph/badge.svg)](https://codecov.io/github/tidyverse/blob?branch=main)
<!-- badges: end -->

<!-- README.md is generated from README.Rmd. Please edit that file -->

```{r, include = FALSE}
pkgload::load_all()

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.path = "README-"
)
```

# blob

## Overview

The goal of blob is to provide a simple S3 class to represent a vector of binary objects, aka blobs. The `blob` class is a lightweight wrapper around a list of raw vectors, suitable for inclusion in a data frame.

In most cases you will not need to use this package explicitly: it will be used transparently by packages that need to load BLOB columns from databases or binary file formats.

## Installation

```r
# The easiest way to get blob is to install the whole tidyverse:
install.packages("tidyverse")

# Alternatively, install just blob:
install.packages("blob")

# Or the the development version from GitHub:
# install.packages("devtools")
devtools::install_github("tidyverse/blob")
```

## Example

To create a blob, use `blob()`, `new_blob()` or `as_blob()`:

```{r example}
library(blob)

x1 <- charToRaw("Good morning")
x2 <- as.raw(c(0x48, 0x65, 0x6c, 0x6c, 0x6f))

new_blob(list(x1, x2))
blob(x1, x2)

as_blob(c("Good morning", "Good evening"))
```

---

Please note that the 'blob' project is released with a
[Contributor Code of Conduct](https://github.com/tidyverse/blob/blob/main/CODE_OF_CONDUCT.md).
By contributing to this project, you agree to abide by its terms.

compute_bytes <- function(bytes, smallest_unit = "B") {
  units0 <- c("B", "kB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB")

  stopifnot(
    is.numeric(bytes),
    is.character(smallest_unit),
    length(smallest_unit) == 1,
    !is.na(smallest_unit),
    smallest_unit %in% units0
  )

  negative <- (bytes < 0)
  bytes <- abs(bytes)
  smallest_idx <- match(smallest_unit, units0)

  limits <- c(1000, 999950 * 1000^(seq_len(length(units0) - 2) - 1))
  idx <- cut(bytes, c(0, limits, Inf), labels = FALSE, right = FALSE)
  idx <- pmax(idx, smallest_idx)

  amount <- bytes / signif(c(1, limits), 1)[idx]
  idx[is.na(idx)] <- smallest_idx
  unit <- units0[idx]

  data.frame(
    stringsAsFactors = FALSE,
    amount,
    unit,
    negative
  )
}

pretty_bytes_default <- function(bytes) {
  szs <- compute_bytes(bytes)
  amt <- szs$amount * ifelse(szs$negative, -1, 1)

  is_int <- is.na(amt) | amt == as.integer(amt)

  ## String. For fractions we always show two fraction digits
  res <- ifelse(
    is_int,
    sprintf("%.0f%s", amt, ifelse(all(is_int) | (szs$unit == "B"), "", "   ")),
    sprintf("%.2f", amt)
  )

  format(paste(res, szs$unit), justify = "right")
}

pretty_bytes_nopad <- function(bytes) {
  sub("^\\s+", "", pretty_bytes_default(bytes))
}

is_raw_list <- function(x) {
  if (!is.list(x))
    return(FALSE)

  raw <- vapply(x, is.raw, logical(1))
  null <- vapply(x, is.null, logical(1))

  if (!all(raw | null))
    return(FALSE)

  TRUE
}

as_single_raw <- function(x) {
  if (is.na(x)) NULL else as.raw(x)
}

#' @import vctrs
#' @import rlang
NULL

#' @importFrom methods setOldClass
setOldClass(c("blob", "vctrs_list_of", "vctrs_vctr"))

#' Construct a blob object
#'
#' `new_blob()` is a low-level constructor that takes a list of
#' raw vectors.
#' `blob()` constructs a blob from individual raw vectors.
#' `as_blob()` and `is_blob()` are simple forwarders to [vctrs::vec_cast()]
#' and [inherits()], respectively.
#'
#' @seealso [as.blob()] for the legacy interface for specifying casts.
#'
#' @param ... Individual raw vectors
#' @param x A list of raw vectors, or other object to coerce
#' @export
#' @examples
#' x1 <- charToRaw("Good morning")
#' x2 <- as.raw(c(0x48, 0x65, 0x6c, 0x6c, 0x6f))
#'
#' new_blob(list(x1, x2))
#' blob(x1, x2)
#'
#' as.blob(c("Good morning", "Good evening"))
blob <- function(...) {
  x <- list2(...)
  validate_blob(x)
  new_blob(x)
}

#' @export
#' @rdname blob
new_blob <- function(x = list()) {
  new_list_of(x, ptype = raw(), class = "blob")
}

#' @export
#' @rdname blob
validate_blob <- function(x) {
  x_arg <- as_label(enexpr(x))
  check_raw_list(x, x_arg)
}

check_raw_list <- function(x, x_arg) {
  if (!is_raw_list(x)) {
    stop("`", x_arg, "` must be a list of raw vectors", call. = FALSE)
  }
}

#' @export
#' @rdname blob
as_blob <- function(x) {
  vec_cast(x, new_blob())
}

#' @export
#' @rdname blob
is_blob <- function(x) {
  vec_is(x, new_blob())
}

#' Deprecated generic
#'
#' The `as.blob()` generic has been deprecated in favor of
#' the [as_blob()] function (for users) and the [vec_cast.blob()] method
#' (for implementers).
#' Implement a `vec_cast.blob.myclass()` method to support
#' coercing objects of your class to blobs.
#' See [vctrs::vec_cast()] for more detail.
#'
#' @param x An object.
#' @param ... Passed on to methods.
#'
#' @export
#' @keywords internal
as.blob <- function(x, ...) {
  signal_soft_deprecated("as.blob() is deprecated, use as_blob().")
  UseMethod("as.blob")
}

#' @export
as.blob.default <- function(x, ...) {
  as_blob(x)
}

test_that("subsetting blob returns blob", {
  x <- blob(!!!as.raw(1:5))
  expect_s3_class(x[1], "blob")
})

test_that("subsetting can return NA", {
  x <- blob(!!!as.raw(1:5))
  expect_identical(x[NA_integer_], blob(NULL))
  expect_identical(x[c(5, NA)], blob(as.raw(5L), NULL))
})

test_that("subset assignment works", {
  x <- blob(!!!as.raw(1:5))
  x[3] <- blob(raw(1))
  expect_identical(x, blob(!!!as.raw(c(1:2, 0L, 4:5))))
  x[[4]] <- raw(1)
  expect_identical(x, blob(!!!as.raw(c(1:2, 0L, 0L, 5L))))
  x[7] <- blob(raw(1))
  expect_identical(x, blob(!!!as.raw(c(1:2, 0L, 0L, 5L)), NULL, raw(1)))
})

test_that("can't insert objects of incorrect type", {
  x <- blob(!!!as.raw(1:5))

  expect_error(
    x[[1]] <- 1,
    regexp = "Can't convert `value` <double> to <raw>",
    class = "vctrs_error_incompatible",
    fixed = TRUE
  )
  expect_error(
    x[1] <- 1,
    regexp = "Can't convert `X[[i]]` <double> to <raw>",
    class = "vctrs_error_incompatible",
    fixed = TRUE
  )
})

test_that("can insert raw", {
  x <- blob(!!!as.raw(1:2))

  x[[1]] <- as.raw(0)
  x[2] <- list(as.raw(0))

  expect_equal(x, blob(as.raw(0), as.raw(0)))
})

test_that("`[<-` can insert missing values", {
  # With `list(NULL)`
  x <- blob(raw(1), raw(2), raw(3))
  x[c(1, 3)] <- list(NULL)
  expect_identical(x, blob(NULL, raw(2), NULL))

  # With `blob(NULL)`
  x <- blob(raw(1), raw(2), raw(3))
  x[c(1, 3)] <- blob(NULL)
  expect_identical(x, blob(NULL, raw(2), NULL))
})

test_that("`[<-` shrinks the blob when inserting literal `NULL`", {
  # Because <blob> is implemented on <list_of> and inherits all list-like
  # qualities, for better or worse

  # `<list_of>` method threw an incomprehensible error before this
  skip_if_not_installed("vctrs", "0.6.5.9000")

  x <- blob(raw(1), raw(2))
  x[1] <- NULL
  expect_identical(x, blob(raw(2)))

  x <- blob(raw(1), raw(2), raw(3))
  x[2:3] <- NULL
  expect_identical(x, blob(raw(1)))

  # By name
  x <- blob(a = raw(1), b = raw(2), c = raw(3))
  x[c("b", "c")] <- NULL
  expect_identical(x, blob(a = raw(1)))

  # OOB
  x <- blob(raw(1))
  x[2] <- NULL
  expect_identical(x, blob(raw(1)))
})

test_that("`[[<-` shrinks the blob when inserting literal `NULL`", {
  # Because <blob> is implemented on <list_of> and inherits all list-like
  # qualities, for better or worse

  # `<list_of>` avoided shrinking the list before this, but we've changed that
  # to better align with base R lists
  skip_if_not_installed("vctrs", "0.6.5.9000")

  x <- blob(raw(1), raw(2))
  x[[1]] <- NULL
  expect_identical(x, blob(raw(2)))

  x <- blob(a = raw(1), b = raw(2), c = raw(3))
  x[["b"]] <- NULL
  expect_identical(x, blob(a = raw(1), c = raw(3)))

  # OOB
  x <- blob(raw(1))
  x[[2]] <- NULL
  expect_identical(x, blob(raw(1)))
})

test_that("`$<-` shrinks the blob when inserting literal `NULL`", {
  # Because <blob> is implemented on <list_of> and inherits all list-like
  # qualities, for better or worse

  x <- blob(a = raw(1), b = raw(2), c = raw(3))
  x$b <- NULL
  expect_identical(x, blob(a = raw(1), c = raw(3)))

  # OOB
  x <- blob(a = raw(1))
  x$b <- NULL
  expect_identical(x, blob(a = raw(1)))
})

test_that("can combine", {
  expect_identical(
    c(blob(raw(4), raw(5)), blob(raw(7))),
    blob(raw(4), raw(5), raw(7))
  )
  expect_identical(
    # Doesn't work with c()
    vec_c(list(raw(4), raw(5)), blob(raw(7))),
    blob(raw(4), raw(5), raw(7))
  )
  expect_identical(
    vec_c(list(raw(7)), blob(raw(4), raw(5)), list(raw(7))),
    blob(raw(7), raw(4), raw(5), raw(7))
  )
  expect_identical(
    vec_c(NA, blob()),
    blob(NULL)
  )
  expect_identical(
    c(blob(), NA),
    blob(NULL)
  )
  expect_error(
    c(blob(raw(4), raw(5)), raw(7))
  )
  expect_error(
    c(blob(raw(4), raw(5)), 7)
  )
})

context("test-cast")

test_that("casting with as.blob()", {
  # Deprecated in v1.2.0
  local_lifecycle_silence()

  expect_identical(as.blob(blob(raw(1))), blob(raw(1)))
  expect_identical(as.blob(list(raw(1))), blob(raw(1)))
  expect_identical(as.blob(raw(1)), blob(raw(1)))
  expect_identical(as.blob(1:3), blob(as.raw(1), as.raw(2), as.raw(3)))
  expect_identical(as.blob(c("abc", "def")), blob(charToRaw("abc"), charToRaw("def")))
})

test_that("casting with as_blob()", {
  expect_identical(as_blob(blob(raw(1))), blob(raw(1)))
  expect_identical(as_blob(list(raw(1))), blob(raw(1)))
  expect_identical(as_blob(raw(1)), blob(raw(1)))
  expect_identical(blob(!!!as.raw(1:3)), blob(as.raw(1), as.raw(2), as.raw(3)))
  expect_identical(as_blob(c("abc", "def")), blob(charToRaw("abc"), charToRaw("def")))
})

test_that("NA_character_ is converted to missing blob()", {
  expect_identical(as_blob(NA_character_), blob(NULL))
  expect_identical(as_blob(c("1", NA_character_)), blob(as.raw(0x031), NULL))
})

context("missing")

test_that("is.na detects nulls", {
  x <- blob(as.raw(1), NULL, as.raw(2), NULL)
  expect_equal(is.na(x), c(FALSE, TRUE, FALSE, TRUE))
})

test_that("is.na<- sets missing values", {
  x <- blob(!!!as.raw(1:4))
  is.na(x) <- (1:4 %% 2 == 0)

  expect_equal(x, blob(as.raw(1), NULL, as.raw(3), NULL))
})

test_that("is.na<- auto-expansion for logical indexes", {
  x <- blob(!!!as.raw(1:4))
  expect_error(is.na(x) <- rep(TRUE, 5))
})

test_that("is.na<- auto-expansion for character indices", {
  x <- blob(!!!as.raw(1:4))
  expect_error(is.na(x) <- letters[1:2])
})

context("construction")

test_that("input must be list of raw blobs", {
  # error from vctrs package
  expect_error(new_blob(1))
  expect_error(blob(1), "must be a list of raw vectors")
  expect_error(blob(1, as.raw(1)), "must be a list of raw vectors")
})

context("format")

expect_format_equal <- function(formatted, result) {
  expect_equal(
    paste(formatted, collapse = "\n"),
    paste(result, collapse = "\n")
  )
}

test_that("unequal sizes", {
  skip_on_cran()

  x <- blob(raw(2**2), raw(2**11), raw(2**20))

  expect_format_equal(
    format(x),
    c(
      "blob[4 B]",
      "blob[2.05 kB]",
      "blob[1.05 MB]"
    )
  )

  expect_format_equal(
    format(x, trim = FALSE),
    c(
      "blob[    4 B]",
      "blob[2.05 kB]",
      "blob[1.05 MB]"
    )
  )
})

test_that("similar sizes", {
  skip_on_cran()

  x <- blob(raw(2**10), raw(2**11), raw(2**12))

  expect_format_equal(
    format(x),
    c(
      "blob[1.02 kB]",
      "blob[2.05 kB]",
      "blob[4.10 kB]"
    )
  )
})

test_that("empty", {
  x <- blob()

  expect_format_equal(
    format(x),
    character()
  )
})

test_that("output", {
  skip_on_cran()

  x <- blob(raw(2**2), raw(2**11), raw(2**20))

  expect_known_output(print(x), "blob.txt")
})

#' @export
format.blob <- function(x, ...) {
  if (length(x) == 0)
    return(character())

  ifelse(is.na(x), "<NA>", paste0("blob[", blob_size(x, ...), "]"))
}

#' @export
obj_print_data.blob <- function(x, ...) {
  if (length(x) == 0)
    return()

  out <- stats::setNames(format(x), names(x))
  print(out, quote = FALSE)

  invisible(x)
}

#' @export
vec_ptype_abbr.blob <- function(x, ..., prefix_named, suffix_shape) {
  "blob"
}

#' @export
vec_ptype_full.blob <- function(x, ...) {
  "blob"
}

blob_size <- function(x, digits = 3, trim = TRUE, ...) {
  x <- vapply(x, length, numeric(1))
  if (isTRUE(trim)) {
    pretty_bytes_nopad(x)
  } else {
    pretty_bytes_default(x)
  }
}

# Dynamically exported, see zzz.R
pillar_shaft.blob <- function(x, ...) {
  out <- ifelse(
    is.na(x),
    NA_character_,
    paste0(pillar::style_subtle("<raw "), blob_size(x, ...), pillar::style_subtle(">"))
  )

  pillar::new_pillar_shaft_simple(out, align = "right")
}

# nocov start --- compat-lifecycle

# This file serves as a reference for currently unexported rlang
# lifecycle functions. Please find the most recent version in rlang's
# repository. These functions require rlang in your `Imports`
# DESCRIPTION field but you don't need to import rlang in your
# namespace.

# Changelog
# =========
#
# 2021-04-19
#
# - Removed `lifecycle()` function. You can now use the following in
#   your roxygen documentation to inline a badge:
#
#    ```
#    `r lifecycle::badge()`
#    ```
#
#   This is a build-time dependency on lifecycle so there is no need
#   to add lifecycle to Imports just to use badges. See also
#   `?usethis::use_lifecycle()` for importing or updating the badge
#   images in your package.
#
# - Soft-namespaced private objects.


#' Signal deprecation
#'
#' @description
#'
#' These functions provide two levels of verbosity for deprecation
#' warnings.
#'
#' * `signal_soft_deprecated()` warns only if called from the global
#'   environment (so the user can change their script) or from the
#'   package currently being tested (so the package developer can fix
#'   the package).
#'
#' * `warn_deprecated()` warns unconditionally.
#'
#' * `stop_defunct()` fails unconditionally.
#'
#' Both functions warn only once per session by default to avoid
#' overwhelming the user with repeated warnings.
#'
#' @param msg The deprecation message.
#' @param id The id of the deprecation. A warning is issued only once
#'   for each `id`. Defaults to `msg`, but you should give a unique ID
#'   when the message is built programmatically and depends on inputs.
#' @param env The environment in which the soft-deprecated function
#'   was called. A warning is issued if called from the global
#'   environment. If testthat is running, a warning is also called if
#'   the retired function was called from the package being tested.
#'
#' @section Controlling verbosity:
#'
#' The verbosity of retirement warnings can be controlled with global
#' options. You'll generally want to set these options locally with
#' one of these helpers:
#'
#' * `with_lifecycle_silence()` disables all soft-deprecation and
#'   deprecation warnings.
#'
#' * `with_lifecycle_warnings()` enforces warnings for both
#'   soft-deprecated and deprecated functions. The warnings are
#'   repeated rather than signalled once per session.
#'
#' * `with_lifecycle_errors()` enforces errors for both
#'   soft-deprecated and deprecated functions.
#'
#' All the `with_` helpers have `scoped_` variants that are
#' particularly useful in testthat blocks.
#'
#' @noRd
NULL

signal_soft_deprecated <- function(msg, id = msg, env = rlang::caller_env(2)) {
  msg <- .rlang_lifecycle_validate_message(msg)
  stopifnot(
    rlang::is_string(id),
    rlang::is_environment(env)
  )

  if (rlang::is_true(rlang::peek_option("lifecycle_disable_warnings"))) {
    return(invisible(NULL))
  }

  env_inherits_global <- function(env) {
    # `topenv(emptyenv())` returns the global env. Return `FALSE` in
    # that case to allow passing the empty env when the
    # soft-deprecation should not be promoted to deprecation based on
    # the caller environment.
    if (rlang::is_reference(env, emptyenv())) {
      return(FALSE)
    }

    rlang::is_reference(topenv(env), rlang::global_env())
  }

  if (rlang::is_true(rlang::peek_option("lifecycle_verbose_soft_deprecation")) ||
    env_inherits_global(env)) {
    warn_deprecated(msg, id)
    return(invisible(NULL))
  }

  # Test for environment names rather than reference/contents because
  # testthat clones the namespace
  tested_package <- Sys.getenv("TESTTHAT_PKG")
  if (nzchar(tested_package) &&
    identical(Sys.getenv("NOT_CRAN"), "true") &&
    rlang::env_name(topenv(env)) == rlang::env_name(rlang::ns_env(tested_package))) {
    warn_deprecated(msg, id)
    return(invisible(NULL))
  }

  rlang::signal(msg, "lifecycle_soft_deprecated")
}

warn_deprecated <- function(msg, id = msg) {
  msg <- .rlang_lifecycle_validate_message(msg)
  stopifnot(rlang::is_string(id))

  if (rlang::is_true(rlang::peek_option("lifecycle_disable_warnings"))) {
    return(invisible(NULL))
  }

  if (!rlang::is_true(rlang::peek_option("lifecycle_repeat_warnings")) &&
    rlang::env_has(.rlang_lifecycle_deprecation_env, id)) {
    return(invisible(NULL))
  }

  rlang::env_poke(.rlang_lifecycle_deprecation_env, id, TRUE);

  has_colour <- function() rlang::is_installed("crayon") && crayon::has_color()
  silver <- function(x) if (has_colour()) crayon::silver(x) else x

  if (rlang::is_true(rlang::peek_option("lifecycle_warnings_as_errors"))) {
    .Signal <- stop_defunct
  } else {
    .Signal <- .Deprecated
  }

  if (!rlang::is_true(rlang::peek_option("lifecycle_repeat_warnings"))) {
    msg <- paste0(msg, "\n", silver("This warning is displayed once per session."))
  }

  .Signal(msg = msg)
}
.rlang_lifecycle_deprecation_env <- new.env(parent = emptyenv())

stop_defunct <- function(msg) {
  msg <- .rlang_lifecycle_validate_message(msg)
  err <- rlang::cnd(
    c("defunctError", "error", "condition"),
    old = NULL,
    new = NULL,
    package = NULL,
    message = msg
  )
  stop(err)
}

local_lifecycle_silence <- function(frame = rlang::caller_env()) {
  rlang::local_options(.frame = frame,
    lifecycle_disable_warnings = TRUE
  )
}
with_lifecycle_silence <- function(expr) {
  local_lifecycle_silence()
  expr
}

local_lifecycle_warnings <- function(frame = rlang::caller_env()) {
  rlang::local_options(.frame = frame,
    lifecycle_disable_warnings = FALSE,
    lifecycle_verbose_soft_deprecation = TRUE,
    lifecycle_repeat_warnings = TRUE
  )
}
with_lifecycle_warnings <- function(expr) {
  local_lifecycle_warnings()
  expr
}

local_lifecycle_errors <- function(frame = rlang::caller_env()) {
  local_lifecycle_warnings(frame = frame)
  rlang::local_options(.frame = frame,
    lifecycle_warnings_as_errors = TRUE
  )
}
with_lifecycle_errors <- function(expr) {
  local_lifecycle_errors()
  expr
}

.rlang_lifecycle_validate_message <- function(msg) {
  stopifnot(rlang::is_character(msg))
  paste0(msg, collapse = "\n")
}

# nocov end

#' Casting
#'
#' Double dispatch methods to support [vctrs::vec_cast()].
#'
#' @inheritParams vctrs::vec_cast
#'
#' @keywords internal
#' @method vec_cast blob
#' @export
#' @export vec_cast.blob
vec_cast.blob <- function(x, to, ...) UseMethod("vec_cast.blob")

#' @method vec_cast.blob default
#' @export
vec_cast.blob.default <- function(x, to, ...) vec_default_cast(x, to, ...)

#' @method vec_cast.blob blob
#' @export
vec_cast.blob.blob <- function(x, to, ...) x

#' @method vec_cast.blob list
#' @export
vec_cast.blob.list <- function(x, to, ...) blob(!!!x)

#' @method vec_cast.blob vctrs_list_of
#' @export
vec_cast.blob.vctrs_list_of <- function(x, to, ...) {
  new_blob(vec_cast(x, new_list_of(ptype = raw())))
}

#' @method vec_cast.blob integer
#' @export
vec_cast.blob.integer <- function(x, to, ...) {
  signal_soft_deprecated("Coercing an integer vector to a blob is deprecated, please coerce to a list first.")
  blob(!!!lapply(x, as_single_raw))
}

#' @method vec_cast.blob raw
#' @export
vec_cast.blob.raw <- function(x, to, ...) blob(x)

#' @method vec_cast.blob character
#' @export
vec_cast.blob.character <- function(x, to, ...) {
  out <- as_blob(vector("list", length(x)))
  # charToRaw(NA_character_) == charToRaw("NA"), so only convert non-missing entries
  non_missing <- !is.na(x)
  out[non_missing] <- lapply(x[non_missing], charToRaw)
  out
}

#' Coercion
#'
#' Double dispatch methods to support [vctrs::vec_ptype2()].
#'
#' @inheritParams vctrs::vec_ptype2
#'
#' @method vec_ptype2 blob
#' @export
#' @export vec_ptype2.blob
vec_ptype2.blob <- function(x, y, ..., x_arg = "", y_arg = "") UseMethod("vec_ptype2.blob", y)

#' @method vec_ptype2.blob default
#' @export
vec_ptype2.blob.default <- function(x, y, ..., x_arg = "", y_arg = "") {
  vec_default_ptype2(x, y, x_arg = x_arg, y_arg = y_arg)
}

#' @method vec_ptype2.blob blob
#' @export
vec_ptype2.blob.blob <- function(x, y, ...) {
  new_blob(list())
}

#' @method vec_ptype2.blob list
#' @export
vec_ptype2.blob.list <- function(x, y, ..., x_arg = "", y_arg = "") {
  check_raw_list(y, y_arg)
  new_blob(list())
}

#' @method vec_ptype2.list blob
#' @export
vec_ptype2.list.blob <- function(x, y, ..., x_arg = "", y_arg = "") {
  check_raw_list(x, x_arg)
  new_blob(list())
}

library(drake)
library(tidyverse)
library(glue)

options(repos = revdepcheck:::get_repos(TRUE))

get_this_pkg <- function() {
  desc::desc_get("Package") %>% unname()
}

get_base_pkgs <- function() {
  rownames(installed.packages(priority = "base"))
}

flatten <- . %>% unname() %>% unlist() %>% unique()

retry <- function(code, N = 1) {
  quo <- rlang::enquo(code)

  for (i in seq_len(N)) {
    ret <- tryCatch(rlang::eval_tidy(quo), error = identity)
    if (!inherits(ret, "error")) return(ret)
    Sys.sleep(runif(1) * 2)
  }

  stop(ret)
}

get_plan_deps <- function() {
  plan_deps <- drake_plan(
    available = available.packages(),
    this_pkg = get_this_pkg(),
    revdeps = tools::package_dependencies(this_pkg, available, 'most', reverse = TRUE) %>% flatten(),
    first_level_deps = tools::package_dependencies(revdeps, available, 'most'),
    all_level_deps = tools::package_dependencies(first_level_deps %>% flatten(), available, recursive = TRUE),
    base_pkgs = get_base_pkgs(),
    deps = c(revdeps, first_level_deps, all_level_deps) %>% flatten() %>% tools::package_dependencies(recursive = TRUE) %>% .[!(names(.) %in% base_pkgs)],
    strings_in_dots = "literals"
  )

  plan_deps
}

source("revdep/drake-base.R")

subset_available <- function(available, pkg) {
  if (pkg %in% rownames(available)) {
    available[pkg, , drop = FALSE]
  } else {
    available[integer(), , drop = FALSE]
  }
}

download <- function(pkg, available, ...) {
  dir <- fs::dir_create("revdep/download")
  dir <- fs::path_real(dir)

  withr::with_options(
    list(warn = 2),
    download.packages(pkg, dir, available = available)[, 2]
  )
}

get_i_lib <- function() {
  path <- "revdep/libs/cran"
  fs::dir_create(path)
  fs::path_real(path)
}

install <- function(pkg, path, ...) {
  dep_packages <- list(...)
  dep_paths <- map_chr(dep_packages, attr, "path")
  stopifnot(all(fs::dir_exists(dep_paths)))

  deps <- c(pkg, sort(as.character(unique(unlist(map(dep_packages, attr, "deps"))))))

  lib <- get_i_lib()

  # Avoid flaky check for compiler availability on mclapply()
  pkgbuild:::cache_set("has_compiler", TRUE)

  withr::with_libpaths(
    lib, action = "replace",
    # Suppress warnings about loaded packages
    retry(suppressWarnings(pkginstall::install_source(path, vignettes = FALSE)))
  )

  structure(
    pkg,
    path = file.path(lib, pkg),
    version = utils::packageVersion(pkg, lib),
    deps = deps
  )
}

get_old_lib <- function() {
  path <- "revdep/libs/old"
  fs::dir_create(path)
  fs::path_real(path)
}

get_new_lib <- function() {
  path <- "revdep/libs/new"
  fs::dir_create(path)
  fs::path_real(path)
}

create_lib <- function(pkg, lib) {
  fs::dir_create(lib)

  target <- fs::path(lib, pkg)
  fs::link_delete(target[fs::link_exists(target)])
  fs::link_create(fs::path(get_i_lib(), pkg), target)
  lib
}

create_new_lib <- function(old_lib, new_lib) {
  lib <- c(new_lib, old_lib)
  withr::with_libpaths(lib, action = "replace", {
    remotes::install_local(".")
  })

  lib
}

get_pkg_and_deps <- function(i_pkg) {
  get_deps(i_pkg)
}

get_deps <- function(i_pkg) {
  attr(i_pkg, "deps")
}

check <- function(tarball, lib, ...) {
  pkgs <- c(...)
  check_lib <- fs::file_temp("checklib")
  create_lib(pkgs, check_lib)
  withr::with_libpaths(c(lib, check_lib), rcmdcheck::rcmdcheck(tarball, quiet = TRUE, timeout = ignore(600)))
}

compare <- function(old, new) {
  rcmdcheck::compare_checks(old, new)
}

get_plan <- function() {

  plan_deps <- get_plan_deps()
  config_deps <- drake_config(plan_deps)
  if (length(outdated(config_deps, make_imports = FALSE)) > 0) {
    warning("Making dependencies first, rerun.", call. = FALSE)
    return(plan_deps)
  }


# Avoid expensive and flaky check for build tools from pkgbuild
# Leads to errors, need to check!
#options(buildtools.check = identity)

  deps <- readd(deps)

  make_subset_available <- function(pkg) {
    expr(subset_available(available, !!pkg))
  }

  plan_available <-
    deps %>%
    enframe() %>%
    transmute(
      target = glue("av_{name}"),
      call = map(name, make_subset_available)
    ) %>%
    deframe() %>%
    drake_plan(list = .)

  make_download <- function(pkg, my_pkgs) {
    av_pkg <- sym(glue("av_{pkg}"))
    deps <- list()
    if (!(pkg %in% my_pkgs)) {
      deps <- c(deps, expr(old_lib))
    }

    expr(download(!!pkg, available = !!av_pkg, !!!deps))
  }

  plan_download <-
    deps %>%
    enframe() %>%
    transmute(
      target = glue("d_{name}"),
      call = map(name, make_download, c(get_this_pkg(), deps[[get_this_pkg()]]))
    ) %>%
    deframe() %>%
    drake_plan(list = .)

  make_install <- function(pkg, dep_list) {
    d_pkg <- sym(glue("d_{pkg}"))
    expr(install(!!pkg, path = !!d_pkg, !!! dep_list))
  }

  create_dep_list <- function(deps, base_pkgs) {
    valid_deps <- setdiff(deps, base_pkgs)
    syms(glue("i_{valid_deps}"))
  }

  plan_install <-
    deps %>%
    enframe() %>%
    mutate(target = glue("i_{name}")) %>%
    mutate(
      dep_list = map(value, create_dep_list, readd(base_pkgs)),
      call = map2(name, dep_list, make_install)
    ) %>%
    select(target, call) %>%
    deframe() %>%
    drake_plan(list = .)

  plan_base_libs <- drake_plan(
    old_lib = create_lib(get_pkg_and_deps(!!sym(glue("i_{get_this_pkg()}"))), get_old_lib()),
    new_lib = create_new_lib(old_lib, get_new_lib())
  )

  make_check <- function(pkg, lib, deps, first_level_deps, base_pkgs) {
    lib <- enexpr(lib)

    req_pkgs <- first_level_deps[[pkg]]
    req_pkgs_deps <- deps[c(pkg, req_pkgs)] %>% unname() %>% unlist() %>% unique()
    all_deps <- c(req_pkgs, req_pkgs_deps) %>% unique()

    i_deps <- create_dep_list(all_deps, base_pkgs)
    d_dep <- sym(glue("d_{pkg}"))

    expr(check(!!d_dep, !!lib, !!! i_deps))
  }

  plan_check <-
    readd(revdeps) %>%
    enframe() %>%
    mutate(
      old = map(value, make_check, old_lib, readd(deps), readd(first_level_deps), readd(base_pkgs)),
      new = map(value, make_check, new_lib, readd(deps), readd(first_level_deps), readd(base_pkgs))
    ) %>%
    gather(kind, call, old, new) %>%
    transmute(
      target = glue("c_{value}_{kind}"),
      call
    ) %>%
    deframe() %>%
    drake_plan(list = .)

  make_compare <- function(pkg) {
    old_result <- sym(glue("c_{pkg}_old"))
    new_result <- sym(glue("c_{pkg}_new"))
    expr(compare(!!old_result, !!new_result))
  }

  plan_compare <-
    readd(revdeps) %>%
    enframe() %>%
    transmute(
      target = glue("c_{value}"),
      call = map(value, make_compare)
    ) %>%
    deframe() %>%
    drake_plan(list = .)

  make_compare_all <- function(pkg) {
    check_targets <- set_names(syms(glue("c_{pkg}")), pkg)
    expr(list(!!! check_targets))
  }

  plan_compare_all <-
    readd(revdeps) %>%
    enframe() %>%
    summarize(
      target = "compare_all",
      call = list(make_compare_all(value))
    ) %>%
    deframe() %>%
    drake_plan(list = .)

  #future::plan(future.callr::callr)

  plan <-
    bind_rows(
      # Put first to give higher priority
      plan_check,
      plan_compare,
      plan_compare_all,
      plan_install,
      plan_base_libs,
      plan_download,
      plan_available,
      plan_deps
    )

  plan
}

plan <- get_plan()

#trace(conditionCall.condition, recover)
make(
  plan,
  #"compare_all",
  keep_going = TRUE,
  #parallelism = "future"
  , verbose = 3
  , jobs = parallel::detectCores() - 2
)

blob 1.2.3

## Cran Repository Policy

- [x] Reviewed CRP last edited 2022-02-08.

## R CMD check results

- [x] Checked locally, R 4.1.2
- [x] Checked on CI system, R 4.1.3
- [x] Checked on win-builder, R devel

## Current CRAN check results

- [x] Checked on 2022-04-10, no problems found.

# Getting help with blob

Thanks for using blob!
Before filing an issue, there are a few places to explore and pieces to put together to make the process as smooth as possible.

## Make a reprex

Start by making a minimal **repr**oducible **ex**ample using the  [reprex](https://reprex.tidyverse.org/) package. 
If you haven't heard of or used reprex before, you're in for a treat! 
Seriously, reprex will make all of your R-question-asking endeavors easier (which is a pretty insane ROI for the five to ten minutes it'll take you to learn what it's all about). 
For additional reprex pointers, check out the [Get help!](https://www.tidyverse.org/help/) section of the tidyverse site.

## Where to ask?

Armed with your reprex, the next step is to figure out [where to ask](https://www.tidyverse.org/help/#where-to-ask). 

*   If it's a question: start with [community.rstudio.com](https://community.rstudio.com/), and/or StackOverflow. There are more people there to answer questions.  

*   If it's a bug: you're in the right place, [file an issue](https://github.com/batpigandme/blob/issues/new).  
  
*   If you're not sure: let the community help you figure it out! 
    If your problem _is_ a bug or a feature request, you can easily return here and report it. 

Before opening a new issue, be sure to [search issues and pull requests](https://github.com/batpigandme/blob/issues) to make sure the bug hasn't been reported and/or already fixed in the development version. 
By default, the search will be pre-populated with `is:issue is:open`. 
You can [edit the qualifiers](https://help.github.com/articles/searching-issues-and-pull-requests/)  (e.g. `is:pr`, `is:closed`) as needed. 
For example, you'd simply remove `is:open` to search _all_ issues in the repo, open or closed.

## What happens next?

To be as efficient as possible, development of tidyverse packages tends to be very bursty, so you shouldn't worry if you don't get an immediate response.
Typically we don't look at a repo until a sufficient quantity of issues accumulates, then there’s a burst of intense activity as we focus our efforts. 
That makes development more efficient because it avoids expensive context switching between problems, at the cost of taking longer to get back to you. 
This process makes a good reprex particularly important because it might be multiple months between your initial report and when we start working on it. 
If we can’t reproduce the bug, we can’t fix it!

---
name: Bug report or feature request
about: Describe a bug you've seen or make a case for a new feature
---

Please briefly describe your problem and what output you expect. If you have a question, please don't use this form. Instead, ask on <https://stackoverflow.com/> or <https://community.rstudio.com/>.

Please include a minimal reproducible example (AKA a reprex). If you've never heard of a [reprex](http://reprex.tidyverse.org/) before, start by reading <https://www.tidyverse.org/help/#reprex>.

Brief description of the problem

```r
# insert reprex here
```

# Contributing to blob

This outlines how to propose a change to blob. 
For more detailed info about contributing to this, and other tidyverse packages, please see the
[**development contributing guide**](https://rstd.io/tidy-contrib). 

## Fixing typos

You can fix typos, spelling mistakes, or grammatical errors in the documentation directly using the GitHub web interface, as long as the changes are made in the _source_ file. 
This generally means you'll need to edit [roxygen2 comments](https://roxygen2.r-lib.org/articles/roxygen2.html) in an `.R`, not a `.Rd` file. 
You can find the `.R` file that generates the `.Rd` by reading the comment in the first line.

## Bigger changes

If you want to make a bigger change, it's a good idea to first file an issue and make sure someone from the team agrees that it’s needed. 
If you’ve found a bug, please file an issue that illustrates the bug with a minimal 
[reprex](https://www.tidyverse.org/help/#reprex) (this will also help you write a unit test, if needed).

### Pull request process

*   Fork the package and clone onto your computer. If you haven't done this before, we recommend using `usethis::create_from_github("batpigandme/blob", fork = TRUE)`.

*   Install all development dependences with `devtools::install_dev_deps()`, and then make sure the package passes R CMD check by running `devtools::check()`. 
    If R CMD check doesn't pass cleanly, it's a good idea to ask for help before continuing. 
*   Create a Git branch for your pull request (PR). We recommend using `usethis::pr_init("brief-description-of-change")`.

*   Make your changes, commit to git, and then create a PR by running `usethis::pr_push()`, and following the prompts in your browser.
    The title of your PR should briefly describe the change.
    The body of your PR should contain `Fixes #issue-number`.

*  For user-facing changes, add a bullet to the top of `NEWS.md` (i.e. just below the first header). Follow the style described in <https://style.tidyverse.org/news.html>.

### Code style

*   New code should follow the tidyverse [style guide](https://style.tidyverse.org). 
    You can use the [styler](https://CRAN.R-project.org/package=styler) package to apply these styles, but please don't restyle code that has nothing to do with your PR.  

*  We use [roxygen2](https://cran.r-project.org/package=roxygen2), with [Markdown syntax](https://roxygen2.r-lib.org/articles/rd-formatting.html), for documentation.  

*  We use [testthat](https://cran.r-project.org/package=testthat) for unit tests. 
   Contributions with test cases included are easier to accept.  

## Code of Conduct

Please note that the blob project is released with a
[Contributor Code of Conduct](CODE_OF_CONDUCT.md). By contributing to this
project you agree to abide by its terms.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/blob.R
\name{as.blob}
\alias{as.blob}
\title{Deprecated generic}
\usage{
as.blob(x, ...)
}
\arguments{
\item{x}{An object.}

\item{...}{Passed on to methods.}
}
\description{
The \code{as.blob()} generic has been deprecated in favor of
the \code{\link[=as_blob]{as_blob()}} function (for users) and the \code{\link[=vec_cast.blob]{vec_cast.blob()}} method
(for implementers).
Implement a \code{vec_cast.blob.myclass()} method to support
coercing objects of your class to blobs.
See \code{\link[vctrs:vec_cast]{vctrs::vec_cast()}} for more detail.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/blob.R
\name{blob}
\alias{blob}
\alias{new_blob}
\alias{validate_blob}
\alias{as_blob}
\alias{is_blob}
\title{Construct a blob object}
\usage{
blob(...)

new_blob(x = list())

validate_blob(x)

as_blob(x)

is_blob(x)
}
\arguments{
\item{...}{Individual raw vectors}

\item{x}{A list of raw vectors, or other object to coerce}
}
\description{
\code{new_blob()} is a low-level constructor that takes a list of
raw vectors.
\code{blob()} constructs a blob from individual raw vectors.
\code{as_blob()} and \code{is_blob()} are simple forwarders to \code{\link[vctrs:vec_cast]{vctrs::vec_cast()}}
and \code{\link[=inherits]{inherits()}}, respectively.
}
\examples{
x1 <- charToRaw("Good morning")
x2 <- as.raw(c(0x48, 0x65, 0x6c, 0x6c, 0x6f))

new_blob(list(x1, x2))
blob(x1, x2)

as.blob(c("Good morning", "Good evening"))
}
\seealso{
\code{\link[=as.blob]{as.blob()}} for the legacy interface for specifying casts.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coerce.R
\name{vec_ptype2.blob}
\alias{vec_ptype2.blob}
\title{Coercion}
\usage{
\method{vec_ptype2}{blob}(x, y, ..., x_arg = "", y_arg = "")
}
\arguments{
\item{x, y}{Vector types.}

\item{...}{These dots are for future extensions and must be empty.}

\item{x_arg, y_arg}{Argument names for \code{x} and \code{y}. These are used
in error messages to inform the user about the locations of
incompatible types (see \code{\link[vctrs:stop_incompatible_type]{stop_incompatible_type()}}).}
}
\description{
Double dispatch methods to support \code{\link[vctrs:vec_ptype2]{vctrs::vec_ptype2()}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/blob-package.R
\docType{package}
\name{blob-package}
\alias{blob-package}
\title{blob: A Simple S3 Class for Representing Vectors of Binary Data ('BLOBS')}
\description{
R's raw vector is useful for storing a single binary object. What if you want to put a vector of them in a data frame? The 'blob' package provides the blob object, a list of raw vectors, suitable for use as a column in data frame.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://blob.tidyverse.org}
  \item \url{https://github.com/tidyverse/blob}
  \item Report bugs at \url{https://github.com/tidyverse/blob/issues}
}

}
\author{
\strong{Maintainer}: Kirill Müller \email{kirill@cynkra.com}

Authors:
\itemize{
  \item Hadley Wickham
}

Other contributors:
\itemize{
  \item RStudio [copyright holder, funder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cast.R
\name{vec_cast.blob}
\alias{vec_cast.blob}
\title{Casting}
\usage{
\method{vec_cast}{blob}(x, to, ...)
}
\arguments{
\item{x}{Vectors to cast.}

\item{to}{Type to cast to. If \code{NULL}, \code{x} will be returned as is.}

\item{...}{For \code{vec_cast_common()}, vectors to cast. For
\code{vec_cast()}, \code{vec_cast_default()}, and \code{vec_restore()}, these
dots are only for future extensions and should be empty.}
}
\description{
Double dispatch methods to support \code{\link[vctrs:vec_cast]{vctrs::vec_cast()}}.
}
\keyword{internal}
